#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <termios.h>
#include <unistd.h>
#include <errno.h>
#include <iostream>
#include "pr.cpp"

using namespace std;

#ifndef STDIN_FILENO
  #define STDIN_FILENO 0
#endif

extern int errno;                 

static struct termios termattr, save_termattr;
static int ttysavefd = -1;
static enum 
{ 
  RESET, RAW 
} ttystate = RESET;

/* ***************************************************************************
 *
 * set_tty_raw(), put the user's TTY in one-character-at-a-time mode.
 * returns 0 on success, -1 on failure.
 *
 *************************************************************************** */
int set_tty_raw(void) 
{
  int i;

  i = tcgetattr (STDIN_FILENO, &termattr);
  if (i < 0) 
  {
    printf("tcgetattr() returned %d for fildes=%d\n",i,STDIN_FILENO); 
    perror ("");
    return -1;
  }
  save_termattr = termattr;

  termattr.c_lflag &= ~(ECHO | ICANON | IEXTEN | ISIG);
  termattr.c_iflag &= ~(BRKINT | ICRNL | INPCK | ISTRIP | IXON);
  termattr.c_cflag &= ~(CSIZE | PARENB);
  termattr.c_cflag |= CS8;
  termattr.c_oflag &= ~(OPOST);
   
  termattr.c_cc[VMIN] = 1;  /* or 0 for some Unices;  see note 1 */
  termattr.c_cc[VTIME] = 0;

  i = tcsetattr (STDIN_FILENO, TCSANOW, &termattr);
  if (i < 0) 
  {
    printf("tcsetattr() returned %d for fildes=%d\n",i,STDIN_FILENO); 
    perror("");
    return -1;
  }
   
  ttystate = RAW;
  ttysavefd = STDIN_FILENO;

  return 0;
}

/* ***************************************************************************
 *
 * set_tty_cooked(), restore normal TTY mode. Very important to call
 *   the function before exiting else the TTY won't be too usable.
 * returns 0 on success, -1 on failure.
 *
 *************************************************************************** */
int set_tty_cooked() 
{
  int i;
  if (ttystate != RAW) 
  {
    return 0;
  }
  i = tcsetattr (STDIN_FILENO, TCSAFLUSH, &save_termattr);
  if (i < 0) 
  {
    return -1;
  }
  ttystate = RESET;
  return 0;
}

/* ***************************************************************************
 *
 * kb_getc(), wait for a character to be typed and return it.
 *
 *************************************************************************** */
unsigned char kb_getc(void) 
{
  unsigned char ch;
  size_t size;

  while (1)
  {

    usleep(20000);        // 1/50th second

    size = read (STDIN_FILENO, &ch, 1);
    if (size > 0)
    {
      break;
    }
  }
  return ch;
}


#define MM 8
#define AD 9
#define DD 3
#define DED 4
#define WD 4
#define ID 3
#define SD 3
#define QD 2









void add()
{

	string ad[AD]=	{	"\t\t\tWelcome to Basic Banking App -- Add Account\n\n",
			"\n\t>\tName:\t",
			"\n\t \tAge:\t",
			"\n\t \tType:\t",
			"\n\t \tSex:\t",
			"\n\t \tOccupation:\t",
			"\n\t \tOpening Balance:\t",
			"\n\t \tAddress:\t",
			"\n\t \tSubmit:\t\n\n"
		};

	unsigned char ch;
	int pointer=1, arrpos=ad[1].find('>',0)+1;	// arrpos -- Arrow (>) position

	char name[100]="\0";
	int age=0;
	char type=0, sex=0, occupation[20]="\0";
	long double opening_balance=-1;
	char address[256]="\0";
	
	int corracount=0;

	int flag=1;
	string aget;
	string obt;

	set_tty_cooked();	// set COOKED (default) mode

	while(1)
	{
		system("clear");
		for(int i=0;i<AD;i++)
			cout<<ad[i];
		fflush(stdout);
		set_tty_raw();		// set RAW mode

		ch = kb_getc();
		if(ch==27)
		{
			ch = kb_getc();
			if(ch==91)
			{
				ch = kb_getc();
				switch(ch)
				{
					case 65:
						ad[pointer].replace(0,arrpos,"\n\t ");
						if(pointer==1)
							pointer=AD-1;
						else
							pointer--;
						ad[pointer].replace(0,arrpos-1,"\n\t>");
						break;
					case 66:
						ad[pointer].replace(0,arrpos,"\n\t ");
						if(pointer==AD-1)
							pointer=1;
						else
							pointer++;
						ad[pointer].replace(0,arrpos-1,"\n\t>");
						break;
					case 67:	// RIGHT ARROW
						switch(pointer)
						{
							case 1:
								set_tty_cooked();	// set COOKED (default) mode
								cout<<"Enter name:  ";fflush(stdout);
								gets(name);
								corracount++;
								ad[1]="\n\t>\tName:\t";
								ad[1].append(name);
								break;
							case 2:
								set_tty_cooked();	// set COOKED (default) mode
								cout<<"Enter age:  ";fflush(stdout);
								
								cin>>aget;
								flag=1;
								for( int i = 0; i < aget.size(); i++) {
									if(!(aget[i] >= '0' && aget[i] <= '9'))
									{
										flag=0;
										break;
									}
								}
								if(flag==1)
								{
									age=atoi(aget.c_str());
									corracount++;
									ad[2]="\n\t>\tAge:\t";
									ad[2].append(aget);
								}
								else
								{
									cout<<"Not numeric";
									fflush(stdout);set_tty_raw();kb_getc();set_tty_cooked();
								}
								break;
							case 3:
								set_tty_cooked();	// set COOKED (default) mode
								cout<<"Enter type of account:  ";fflush(stdout);
								cin>>type;
								if(type != 'c' && type!='s')
								{
									type=0;
									cout<<"Either c or s";
									fflush(stdout);set_tty_raw();kb_getc();set_tty_cooked();
								}
								else
								{
									corracount++;
									ad[3]="\n\t>\tType:\t";
									ad[3].append(1,type);
								}
								break;
							case 4:
								set_tty_cooked();	// set COOKED (default) mode
								cout<<"Enter sex:  ";fflush(stdout);
								cin>>sex;
								if(sex != 'm' && sex!='f')
								{
									sex=0;
									cout<<"Either m or f";
									fflush(stdout);set_tty_raw();kb_getc();set_tty_cooked();
								}
								else
								{
									corracount++;
									ad[4]="\n\t>\tSex:\t";
									ad[4].append(1,sex);
								}
								break;
							case 5:
								set_tty_cooked();	// set COOKED (default) mode
								cout<<"Enter occupation:  ";fflush(stdout);
								scanf("%s",&occupation);
								corracount++;
								ad[5]="\n\t>\tOccupation:\t";
								ad[5].append(occupation);
								break;
							case 6:
								set_tty_cooked();	// set COOKED (default) mode
								cout<<"Enter opening balance:  ";
								fflush(stdout);

								cin>>obt;
								flag=1;
								for( int i = 0; i < obt.size(); i++) {
									if(!((obt[i] >= '0' && obt[i] <= '9') || obt[i]=='.'))
									{
										flag=0;
										break;
									}
								}
								if(flag==1)
								{
									opening_balance=atof(obt.c_str());
									corracount++;
									if(opening_balance<1000)
									{
										opening_balance=-1;
										cout<<"Should be greater than 1000";
										fflush(stdout);set_tty_raw();kb_getc();set_tty_cooked();
									}
									else
									{
										corracount++;
										ad[6]="\n\t>\tOpening Balance:\t";
										ad[6].append(obt);
									}
								}
								else
								{
									cout<<"Not numeric";
									fflush(stdout);set_tty_raw();kb_getc();set_tty_cooked();
								}
								break;
							case 7:
								set_tty_cooked();	// set COOKED (default) mode
								cout<<"Enter address:  ";fflush(stdout);
								gets(address);
								corracount++;
								ad[7]="\n\t>\tAddress:\t";
								ad[7].append(address);
								break;
							case 8:
								set_tty_cooked();	// set COOKED (default) mode
								if(corracount<7) 
								{
									cout<<"Incomplete info";
									fflush(stdout);set_tty_raw();kb_getc();set_tty_cooked();
								}
								else
								{
									int t=add_acc(name,age,type,sex,occupation,opening_balance,address);
									if(t==1)
										cout<<"File open error";
									else
										cout<<"Account added\nAccount number: "<<t;
									fflush(stdout);set_tty_raw();kb_getc();set_tty_cooked();
								}
								break;
						}
						set_tty_raw();		// set RAW mode
						break;
					case 68:	// LEFT ARROW
						ad[pointer].replace(0,arrpos,"\n\t ");
						ad[1].replace(0,arrpos,"\n\t>");
						return;
						break;
				}

			}
		}
		set_tty_cooked();	// set COOKED (default) mode
	}

}


void del()
{
	string dd[DD]=	{	"\t\t\tWelcome to Basic Banking App -- Delete Account\n\n",
			"\n\t>\tAccount number:\t",
			"\n\t \tSubmit:\t\n\n"
		};

	unsigned char ch;
	int pointer=1, arrpos=dd[1].find('>',0)+1;	// arrpos -- Arrow (>) position

	char temp[30];
	int flag=1;
	int corrdcount=0;

	long int accountnumber=0;
	set_tty_cooked();	// set COOKED (default) mode

	while(1)
	{
		system("clear");
		for(int i=0;i<DD;i++)
			cout<<dd[i];
		fflush(stdout);
		set_tty_raw();		// set RAW mode

		ch = kb_getc();
		if(ch==27)
		{
			ch = kb_getc();
			if(ch==91)
			{
				ch = kb_getc();
				switch(ch)
				{
					case 65:
						dd[pointer].replace(0,arrpos,"\n\t ");
						if(pointer==1)
							pointer=DD-1;
						else
							pointer--;
						dd[pointer].replace(0,arrpos-1,"\n\t>");
						break;
					case 66:
						dd[pointer].replace(0,arrpos,"\n\t ");
						if(pointer==DD-1)
							pointer=1;
						else
							pointer++;
						dd[pointer].replace(0,arrpos-1,"\n\t>");
						break;
					case 67:	// RIGHT ARROW
						switch(pointer)
						{
							case 1:
								set_tty_cooked();	// set COOKED (default) mode
								cout<<"Enter account number:  ";fflush(stdout);
								cin>>accountnumber;
								corrdcount++;
								
								sprintf(temp,"\n\t>\tAccount number:\t%ld",accountnumber);
								dd[1]=string(temp);
								break;
							case 2:
								set_tty_cooked();	// set COOKED (default) mode
								if(corrdcount<1) 
								{
									cout<<"Incomplete info";
									fflush(stdout);set_tty_raw();kb_getc();set_tty_cooked();
								}
								else
								{
									int t=delete_acc(accountnumber);
									if(t==1)
										cout<<"File open error";
									else if(t==2)
										cout<<"Please enter a valid account number!";
									else
										cout<<"Account deleted";
									fflush(stdout);set_tty_raw();kb_getc();set_tty_cooked();
								}
								break;
						}
						set_tty_raw();		// set RAW mode
						break;
					case 68:	// LEFT ARROW
						dd[pointer].replace(0,arrpos,"\n\t ");
						dd[1].replace(0,arrpos,"\n\t>");
						return;
						break;
				}

			}
		}
		set_tty_cooked();	// set COOKED (default) mode
	}

}


void search()
{
	string sd[SD]=	{	"\t\t\tWelcome to Basic Banking App -- Search\n\n",
			"\n\t>\tAccount number:\t",
			"\n\t \tSubmit:\t\n\n"
		};

	unsigned char ch;
	int pointer=1, arrpos=sd[1].find('>',0)+1;	// arrpos -- Arrow (>) position

	long int accountnumber=0;
	int corrscount=0;

	char temp[30];
	int flag=1;


	set_tty_cooked();	// set COOKED (default) mode

	while(1)
	{
		system("clear");
		for(int i=0;i<SD;i++)
			cout<<sd[i];
		fflush(stdout);
		set_tty_raw();		// set RAW mode

		ch = kb_getc();
		if(ch==27)
		{
			ch = kb_getc();
			if(ch==91)
			{
				ch = kb_getc();
				switch(ch)
				{
					case 65:
						sd[pointer].replace(0,arrpos,"\n\t ");
						if(pointer==1)
							pointer=SD-1;
						else
							pointer--;
						sd[pointer].replace(0,arrpos-1,"\n\t>");
						break;
					case 66:
						sd[pointer].replace(0,arrpos,"\n\t ");
						if(pointer==SD-1)
							pointer=1;
						else
							pointer++;
						sd[pointer].replace(0,arrpos-1,"\n\t>");
						break;
					case 67:	// RIGHT ARROW
						switch(pointer)
						{
							case 1:
								set_tty_cooked();	// set COOKED (default) mode
								cout<<"Enter account number:  ";fflush(stdout);
								cin>>accountnumber;
								corrscount++;
								sprintf(temp,"\n\t>\tAccount number:\t%ld",accountnumber);
								sd[1]=string(temp);
								break;
							case 2:
								set_tty_cooked();	// set COOKED (default) mode
								if(corrscount<1)
								{ 
									cout<<"Incomplete info";
									fflush(stdout);set_tty_raw();kb_getc();set_tty_cooked();
								}
								else
								{
									customerinfo customer=search_acc(accountnumber);
									if(customer.age==-1)
										cout<<"Please enter a valid account number!";
									else if(customer.age==-2)
										cout<<"File open error";
									else
									{
										system("clear");
										cout<<"Name: "<<customer.name;
										cout<<"\nAge: "<<customer.age;
										cout<<"\nType: "<<customer.type;
										cout<<"\nSex: "<<customer.sex;
										cout<<"\nOccupation: "<<customer.occupation;
										cout<<"\nBalance: "<<customer.balance;
										cout<<"\nAddress: "<<customer.address;
										cout<<"\nPress Enter.";	
									}
									fflush(stdout);set_tty_raw();kb_getc();set_tty_cooked();
								}
								break;
						}
						set_tty_raw();		// set RAW mode
						break;
					case 68:	// LEFT ARROW
						sd[pointer].replace(0,arrpos,"\n\t ");
						sd[1].replace(0,arrpos,"\n\t>");
						return;
						break;
				}

			}
		}
		set_tty_cooked();	// set COOKED (default) mode
	}

}

void dep()
{
	string ded[DED]={	"\t\t\t\t\tWelcome to Basic Banking App -- Deposit\n\n",
			"\n\t>\tAccount number:\t",
			"\n\t \tDeposit amount:\t",
			"\n\t \tSubmit:\t\n\n"
		};



	unsigned char ch;
	int pointer=1, arrpos=ded[1].find('>',0)+1;	// arrpos -- Arrow (>) position

	long double deposit=0;
	int corrdecount=0;
	long int accountnumber=0;
	char temp[30];

	string depositt;
	int flag=1;


	set_tty_cooked();	// set COOKED (default) mode

	while(1)
	{
		system("clear");
		for(int i=0;i<DED;i++)
			cout<<ded[i];
		fflush(stdout);
		set_tty_raw();		// set RAW mode

		ch = kb_getc();
		if(ch==27)
		{
			ch = kb_getc();
			if(ch==91)
			{
				ch = kb_getc();
				switch(ch)
				{
					case 65:
						ded[pointer].replace(0,arrpos,"\n\t ");
						if(pointer==1)
							pointer=DED-1;
						else
							pointer--;
						ded[pointer].replace(0,arrpos-1,"\n\t>");
						break;
					case 66:
						ded[pointer].replace(0,arrpos,"\n\t ");
						if(pointer==DED-1)
							pointer=1;
						else
							pointer++;
						ded[pointer].replace(0,arrpos-1,"\n\t>");
						break;
					case 67:	// RIGHT ARROW
						switch(pointer)
						{
							case 1:
								set_tty_cooked();	// set COOKED (default) mode
								cout<<"Enter account number:  ";fflush(stdout);
								cin>>accountnumber;
								corrdecount++;
								sprintf(temp,"\n\t>\tAccount number:\t%ld",accountnumber);
								ded[1]=string(temp);
								break;
							case 2:
								set_tty_cooked();	// set COOKED (default) mode
								cout<<"Enter deposit amount:  ";fflush(stdout);
								
								cin>>depositt;
								flag=1;
								for( int i = 0; i < depositt.size(); i++) {
									if(!(depositt[i] >= '0' && depositt[i] <= '9'))
									{
										flag=0;
										break;
									}
								}
								if(flag==1)
								{
									deposit=atof(depositt.c_str());
									corrdecount++;
									ded[2]="\n\t>\tDeposit amount:\t";
									ded[2].append(depositt);
								}
								else
								{
									cout<<"Not numeric";
									fflush(stdout);set_tty_raw();kb_getc();set_tty_cooked();
								}
								break;
							case 3:
								set_tty_cooked();	// set COOKED (default) mode
								if(corrdecount<2) 
								{
									cout<<"Incomplete info";
									fflush(stdout);set_tty_raw();kb_getc();set_tty_cooked();
								}
								else
								{
									long double t=deposit_acc(accountnumber, deposit);
									if(t==1)
										cout<<"File open error";
									else if(t==2)
										cout<<"Please enter a valid account number!";
									else
										cout<<"Amount deposited. New Balance: "<<t;
									fflush(stdout);set_tty_raw();kb_getc();set_tty_cooked();
								}
								break;
						}
						set_tty_raw();		// set RAW mode
						break;
					case 68:	// LEFT ARROW
						ded[pointer].replace(0,arrpos,"\n\t ");
						ded[1].replace(0,arrpos,"\n\t>");
						return;
						break;
				}

			}
		}
		set_tty_cooked();	// set COOKED (default) mode
	}

}


void with()
{
	string wd[WD]=	{	"\t\t\tWelcome to Basic Banking App -- Withdrawal\n\n",
			"\n\t>\tAccount number:\t",
			"\n\t \tWithdrawal amount:\t",
			"\n\t \tSubmit:\t\n\n"
		};



	unsigned char ch;
	int pointer=1, arrpos=wd[1].find('>',0)+1;	// arrpos -- Arrow (>) position

	long double with=0;

	char temp[30];
	int corrwcount=0;
	long int accountnumber=0;
	string witht;
	int flag=1;

	
	set_tty_cooked();	// set COOKED (default) mode

	while(1)
	{
		system("clear");
		for(int i=0;i<WD;i++)
			cout<<wd[i];
		fflush(stdout);
		set_tty_raw();		// set RAW mode

		ch = kb_getc();
		if(ch==27)
		{
			ch = kb_getc();
			if(ch==91)
			{
				ch = kb_getc();
				switch(ch)
				{
					case 65:
						wd[pointer].replace(0,arrpos,"\n\t ");
						if(pointer==1)
							pointer=WD-1;
						else
							pointer--;
						wd[pointer].replace(0,arrpos-1,"\n\t>");
						break;
					case 66:
						wd[pointer].replace(0,arrpos,"\n\t ");
						if(pointer==WD-1)
							pointer=1;
						else
							pointer++;
						wd[pointer].replace(0,arrpos-1,"\n\t>");
						break;
					case 67:	// RIGHT ARROW
						switch(pointer)
						{
							case 1:
								set_tty_cooked();	// set COOKED (default) mode
								cout<<"Enter account number:  ";fflush(stdout);
								cin>>accountnumber;
								corrwcount++;
								sprintf(temp,"\n\t>\tAccount number:\t%ld",accountnumber);
								wd[1]=string(temp);
								break;
							case 2:
								set_tty_cooked();	// set COOKED (default) mode
								cout<<"Enter withdrawal amount:  ";fflush(stdout);
								
								cin>>witht;
								flag=1;
								for( int i = 0; i < witht.size(); i++) {
									if(!(witht[i] >= '0' && witht[i] <= '9'))
									{
										flag=0;
										break;
									}
								}
								if(flag==1)
								{
									with=atof(witht.c_str());
									corrwcount++;
									wd[2]="\n\t>\tWithdrawal amount:\t";
									wd[2].append(witht);
								}
								else
								{
									cout<<"Not numeric";
									fflush(stdout);set_tty_raw();kb_getc();set_tty_cooked();
								}
								break;
							case 3:
								set_tty_cooked();	// set COOKED (default) mode
								if(corrwcount<2) 
								{
									cout<<"Incomplete info";
									fflush(stdout);set_tty_raw();kb_getc();set_tty_cooked();
								}
								else
								{
									long double t=withdrawal_acc(accountnumber, with);
									if(t==1)
										cout<<"File open error";
									else if(t==2)
										cout<<"Please enter a valid account number!";
									else if(t==3)
										cout<<"Maximum Withdrawal Allowed is Rs.10000!";
									else if(t==4)
										cout<<"Minimum Balance Required is Rs.500.Kindly Withdraw lesser amount!" ;
									else
										cout<<"Amount withdrawn. New Balance: "<<t;
									fflush(stdout);set_tty_raw();kb_getc();set_tty_cooked();
								}
								break;
						}
						set_tty_raw();		// set RAW mode
						break;
					case 68:	// LEFT ARROW
						wd[pointer].replace(0,arrpos,"\n\t ");
						wd[1].replace(0,arrpos,"\n\t>");
						return;
						break;
				}

			}
		}
		set_tty_cooked();	// set COOKED (default) mode
	}

}

void interest()
{
	string id[ID]=	{	"\t\t\tWelcome to Basic Banking App -- Interest\n\n",
			"\n\t>\tAccount number:\t",
			"\n\t \tSubmit:\t\n\n"
		};

	unsigned char ch;
	int pointer=1, arrpos=id[1].find('>',0)+1;	// arrpos -- Arrow (>) position

	int corricount=0;
	
	char temp[30];
	int flag=1;
	long int accountnumber=0;
	set_tty_cooked();	// set COOKED (default) mode
	while(1)
	{
		system("clear");
		
		for(int i=0;i<ID;i++) 
			cout<<id[i];
		fflush(stdout);
		set_tty_raw();		// set RAW mode
		ch = kb_getc();
		if(ch==27)
		{
			ch = kb_getc();
			if(ch==91)
			{
				ch = kb_getc();
				switch(ch)
				{
					case 65:
						id[pointer].replace(0,arrpos,"\n\t ");
						if(pointer==1)
							pointer=ID-1;
						else
							pointer--;
						id[pointer].replace(0,arrpos-1,"\n\t>");
						break;
					case 66:
						id[pointer].replace(0,arrpos,"\n\t ");
						if(pointer==ID-1)
							pointer=1;
						else
							pointer++;
						id[pointer].replace(0,arrpos-1,"\n\t>");
						break;
					case 67:	// RIGHT ARROW
						switch(pointer)
						{
							case 1:
								set_tty_cooked();	// set COOKED (default) mode
								cout<<"Enter account number:  ";fflush(stdout);
								cin>>accountnumber;
								corricount++;
								sprintf(temp,"\n\t>\tAccount number:\t%ld",accountnumber);
								id[1]=string(temp);
								break;
							case 2:
								set_tty_cooked();	// set COOKED (default) mode
								if(corricount<1) 
								{
									cout<<"Incomplete info";
									fflush(stdout);set_tty_raw();kb_getc();set_tty_cooked();
								}
								else
								{
									customerinfo customer=search_acc(accountnumber);
									long double t=interest_acc(accountnumber);
									if(t==1)
										cout<<"File open error";
									else if(t==2)
										cout<<"Please enter a valid account number!";
									else
										cout<<"Interest calculated. Old Balance: "<<customer.balance<<". New Balance: "<<t;
									fflush(stdout);set_tty_raw();kb_getc();set_tty_cooked();
								}
								break;
						}
						set_tty_raw();		// set RAW mode
						break;
					case 68:	// LEFT ARROW
						id[pointer].replace(0,arrpos,"\n\t ");
						id[1].replace(0,arrpos,"\n\t>");
						return;
						break;
				}

			}
		}
		set_tty_cooked();	// set COOKED (default) mode
	}

}

int quit()
{
	string qd[QD]=	{	"\t\t\tWelcome to Basic Banking App -- Quit\n\n",
			"\t>\tSure?\t"
		};

	unsigned char ch;
	int pointer=1;

	char check='n';

	system("clear");
	set_tty_cooked();	// set COOKED (default) mode
	for(int i=0;i<QD;i++)
		cout<<qd[i];
	fflush(stdout);

	set_tty_raw();		// set RAW mode
	ch = kb_getc();
	if(ch=='n')
	{
		cout<<ch;
		fflush(stdout);
		return 0;
	}
	else if(ch=='y')
	{
		set_tty_cooked();	// set COOKED (default) mode
		cout<<ch;
		cout<<"\nThank You\n";fflush(stdout);
		return -1;
	}
}




void MainMenu()
{
	string mm[MM]=	{	"\t\t\tWelcome to Basic Banking App\n\n",
			"\n\t>\t1. Add Account",
			"\n\t \t2. Delete Account",
			"\n\t \t3. Deposit",
			"\n\t \t4. Withdrawal",
			"\n\t \t5. Interest",
			"\n\t \t6. Search",
			"\n\t \t7. Quit\n",
		};

	unsigned char ch;
	int pointer=1, arrpos=mm[1].find('>',0)+1;	// arrpos -- Arrow (>) position

	
	while(1)
	{
		system("clear");
		for(int i=0;i<MM;i++)
			cout<<mm[i];

		set_tty_raw();		// set RAW mode
		ch = kb_getc();
		
		if(ch==27)
		{
			ch = kb_getc();
			if(ch==91)
			{
				ch = kb_getc();
				switch(ch)
				{
					case 65:
						mm[pointer].replace(0,arrpos,"\n\t ");
						if(pointer==1)
							pointer=MM-1;
						else
							pointer--;
						mm[pointer].replace(0,arrpos,"\n\t>");
						break;
					case 66:
						mm[pointer].replace(0,arrpos,"\n\t ");
						if(pointer==MM-1)
							pointer=1;
						else
							pointer++;
						mm[pointer].replace(0,arrpos,"\n\t>");
						break;
					case 67:	// RIGHT ARROW
						switch(pointer)
						{
							case 1:
								add();
								break;
							case 2:
								del();
								break;
							case 3:
								dep();
								break;
							case 4:
								with();
								break;
							case 5:
								interest();
								break;
							case 6:
								search();
								break;
							case 7:
								if(quit()==-1)
								{
									return;
								}
								break;
						}
						break;
					case 68:	// LEFT ARROW
						if(quit()==-1)
						{
							return;
						}
						break;
				}

			}
		}
		set_tty_cooked();	// set COOKED (default) mode
	}

}


int main(int argc, char * argv[])
{
	MainMenu();
}

